import java.util.*;

// Exemple de l'utilisation de la collection HashSet
public class Exemple07_HashSet
{
    public static void main(String[] args)
    {
      // Cas d'un HashSet de String
      HashSet<String> setChaine;
      setChaine = new HashSet<String>();
      
      setChaine.add("un");
      setChaine.add("trois");
      setChaine.add("deux");
      setChaine.add("quatre");
      setChaine.add("quatre");
      
      Terminal.ecrireStringln("--1-- Affichage de setChaine");
      for(String s:setChaine)
        Terminal.ecrireStringln(s);
      
      // Rechercher un setChaine
      Terminal.ecrireStringln("--5-- Recherche d'un setChaine");
      if (setChaine.contains("quatre"))
        Terminal.ecrireStringln("quatre trouv");
      else
        Terminal.ecrireStringln("quatre non trouv");

      

      // Cas d'utilisation d'un HashSet avec redefinition des mthodes
      //   equals et hashCode
      //
      Terminal.ecrireStringln("======== Bidule ===============");
      HashSet<Bidule> setBidule;
      setBidule = new HashSet<Bidule>();
      
      setBidule.add(new Bidule(10,11));
      setBidule.add(new Bidule(10,22));
      setBidule.add(new Bidule(10,33));
      setBidule.add(new Bidule(100,44));
      setBidule.add(new Bidule(50,55));
      setBidule.add(new Bidule(60,66));
      setBidule.add(new Bidule(70,77));
      
      Terminal.ecrireStringln("---- Affichage de setBidule");
      for(Bidule b:setBidule)
        Terminal.ecrireStringln(b.toString());
      
      
      // Rechercher un bidule
      Terminal.ecrireStringln("---- Recherche d'un bidule : 10,44");
      if (setBidule.contains(new Bidule(10,44)))
        Terminal.ecrireStringln("Bidule trouv");
      else
        Terminal.ecrireStringln("Bidule non trouv");
      Terminal.ecrireStringln("---- Recherche d'un bidule : 100,44");
      if (setBidule.contains(new Bidule(100,44)))
        Terminal.ecrireStringln("Bidule trouv");
      else
        Terminal.ecrireStringln("Bidule non trouv");
      Terminal.ecrireStringln("---- Recherche d'un bidule : 40,777");
      if (setBidule.contains(new Bidule(40,777)))
        Terminal.ecrireStringln("Bidule trouv");
      else
        Terminal.ecrireStringln("Bidule non trouv");
    }
}

class Bidule
{
  int id;
  int x;
  int y;
  public Bidule(int x,int y){this.x=x;this.y=y;this.id=x*100;}
    public String toString()
  {
    return "("+id+") "+x+"    "+y;
  }
    
  // Il faut definir equals et hashCode
  //
  public boolean equals(Object o)
  {
    return x==((Bidule)o).x;
  }
  
  public int hashCode() 
  {
    return id;
  }
}
